% date.pro: Abstractions about gregorian dates.
% (For interval calculations, Modified Julian Dates (MJD) are more convenient.)
% (c) Author: Frans A. Meijs, 1998

entity(DT) :- date(DT).


elemState__e_entity(Y,DT) :-
   year__e_date(Y,DT).
elemState__e_entity(M,DT) :-
   month__e_date(M,DT).
elemState__e_entity(DM,DT) :-
   dayOfMonth__e_date(DM,DT).
       % This way of specification has been chosen because the 
       % year/month/day  are defined to be constants. 


year__e_date(Y,DT) :-
   nonvar(DT),
   [Y,_,_] = DT.

month__e_date(M,DT) :-
   nonvar(DT),
   [_,M,_] = DT.

dayOfMonth__e_date(DM,DT) :-
   nonvar(DT),
   [_,_,DM] = DT.


% date/1 is not defined because Date is an entity;
% date/1 instances may be defined,
% wellformedness checks are done in Date.prc .


   % Auxiliary theory:
leapYear(Y) :-
   nonvar(Y),
   0 is Y mod 4,
   leapYear__aux(Y).
   
leapYear__aux(Y) :-
   ~(0 is Y mod 100),
   !.                                          % Solution is sufficient.
leapYear__aux(Y) :-   
   0 is Y mod 400.
