% DOCVOLM.PRC: Constraints.


%contradiction(['Contrad. class DOCVOLM1', DVM,
%   'has an improper begin address', BA]) :-
%   beginAddress__e_docVolMembership(BA, DVM),
%   ~( nat(BA) ).
    % Generalized, for HTML hotlinks.


contradiction(['Contrad. class DOCVOLM2', DVM,
   'has an improper number of document volumes', N]) :-
   docVolMembership(DVM),
   propositionSet__has_cardinalNumber(
      docVol__e_docVolMembership(_, DVM),
      N),
   N \== 1.


contradiction(['Contrad. class DOCVOLM3', DVM,
   'has an improper number of documents', N]) :-
   docVolMembership(DVM),
   propositionSet__has_cardinalNumber(
      document__e_docVolMembership(_, DVM),
      N),
   N < 1.


contradiction(['Contrad. class DOCVOLM4', DV,
   'contains members with duplicate begindAdress', BA]) :-
   docVolMembership(DVM1),
   docVol__e_docVolMembership(DV,DVM1),
   beginAddress__e_docVolMembership(BA,DVM1),
   docVol__e_docVolMembership(DV,DVM2),
   id__lt_id(DVM2,DVM1),
   beginAddress__e_docVolMembership(BA,DVM2).


contradiction(['Contrad. class DOCVOLM5', D,
    'is member of both', DVM1, 'and', DVM2]) :-
    document(D),
    document__e_docVolMembership(D, DVM1),
    document__e_docVolMembership(D, DVM2),
    id__lt_id(DVM2,DVM1).
