% FAMILY.PRO: Theory about human families.

hierarchy(H) :- family(H).


connection__e_network(C,N) :-
   connection__connectsTo_node(C,P),
   person__e_family(P,N).
connection__e_network(C,N) :-
   connection__connectsFrom_node(C,P),
   person__isFounderOf_family(P,N).


connection__connectsTo_node(C,N) :-
   person__isParentOf_person(P,N),
   C = [P,N].
   
connection__connectsFrom_node(C,N) :-
   person__isParentOf_person(N,P),
   C = [N,P].

   

person__e_family(P,F) :-
   person__isFounderOf_family(P,F).
person__e_family(P,F) :-
   person__isFounderOf_family(P2,F),
   person__isInLineAncestorOf_person(P2,P).

person__isInLineAncestorOf_person(X,Y) :-
   person__isFatherOf_person(X,Y).
person__isInLineAncestorOf_person(X,Y) :-
   person__isFatherOf_person(X,Z),
   person__isInLineAncestorOf_person(Z,Y).

person__isAncestorOf_person(X,Y) :-
   person__isParentOf_person(X,Y).
person__isAncestorOf_person(X,Y) :-
   person__isParentOf_person(X,Z),
   person__isAncestorOf_person(Z,Y).


person__isAuntOf_person(P1,P2) :-
   person__isSisterOf_person(P1,P3),
   person__isParentOf_person(P3,P2).


person__isUncleOf_person(P1,P2) :-
   person__isBrotherOf_person(P1,P3),
   person__isParentOf_person(P3,P2).


person__isFatherOf_person(X,Y) :-
   person__isParentOf_person(X,Y),
   sex__e_person(male,X).


person__isMotherOf_person(X,Y) :-
   person__isParentOf_person(X,Y),
   sex__e_person(female,X).


person__isBrotherOf_person(P1,P2) :-
   person__isFatherOf_person(P3,P1),
   person__isFatherOf_person(P3,P2),
   sex__e_person(male,P1).

   
person__isSisterOf_person(P1,P2) :-
   person__isFatherOf_person(P3,P1),
   person__isFatherOf_person(P3,P2),
   sex__e_person(female,P1).
   
   



