% mjd.pro: Abstractions about Modified Julian Dates.
% Author: Frans A. Meijs, 15 nov 2004

% This class is particularly intended for interval calculations.
% For presentation purposes it can be mapped into class Date.

% A modified julian date (mJD) is of type int, in number of days.
% Note that before 1582 another calendar has been used, and 1582 itself
% has been a transition period, 
% so a date - reconstructed from a MJD - that has a year <= 1582 does
% in general not correspond with historic records.

date__incrBy_nat__is_date(D2, INCR, D) :-
   mJD__eq_date(MJD2,D2),
   MJD is MJD2 + INCR,
   mJD__eq_date(MJD,D).

