% RADIOST.PRC: The constraints.

contradiction(['Contradiction RADIOST1: Station', RS,
   'has no carrierFrequency']) :-
   o_verifyingLogMsg('RADIOST1'),
   ~( carrierFrequency__e_radioStation(_, RS)).

contradiction(['Contradiction RADIOST2: Station', RS,
   'has an improper carrierFrequency', F]) :-
   o_verifyingLogMsg('RADIOST2'),
   carrierFrequency__e_radioStation(F, RS),
   ~( posnat(F) ).

contradiction(['Contradiction RADIOST3: Program', RP,
   'has an improper day of service', D]) :-
   o_verifyingLogMsg('RADIOST3'),
   dayOfService__e_radioProgram(D, RP),
   ~( elemState__e_sort(D, ['SortOf', 'dayNames']) ).

contradiction(['Contradiction RADIOST4: Program', RP,
   'has an improper begin time', TOD]) :-
   o_verifyingLogMsg('RADIOST3'),
   beginTime__e_radioProgram(TOD, RP),
   ~( wellformedTod(TOD) ).

contradiction(['Contradiction RADIOST5: Program', RP,
   'is no element of a station']) :-
   o_verifyingLogMsg('RADIOST5'),
   radioProgram(RP),
   ~( radioProgram__e_radioStation(RP, _) ).

contradiction(['Contradiction RADIOST6: Program', RP,
   'is element of more than one station']) :-
   o_verifyingLogMsg('RADIOST6'),
   radioProgram(RP),
   propositionSet__has_cardinalNumber(
      radioProgram__e_radioStation(RP, _),
      N),
   N > 1.

