% Tod.pro: Abstractions about time of day.
% (c) Author: Frans A. Meijs, 2003.

% (For interval calculations, daySecs are more convenient.)

entity(TOD) :- tod(TOD).

elemState__e_entity(H,TOD) :-
    hour__e_tod(H,TOD).
elemState__e_entity(M,TOD) :-
    minute__e_tod(M,TOD).
elemState__e_entity(S,TOD) :-
    second__e_tod(S,TOD).
       % This way of specification has been chosen because the 
       % hour/minute/second  are defined to be constants. 

hour__e_tod(H,TOD) :-
    nonvar(TOD),
    [H,_,_] = TOD.
    
minute__e_tod(M,TOD) :-
    nonvar(TOD),
    [_,M,_] = TOD.
    
second__e_tod(S,TOD) :-
    nonvar(TOD),
    [_,_,S] = TOD.
    
% tod/1 is not defined because Tod is an entity;
% tod/1 instances may be defined,
% wellformedness checks are done in Tod.prc .

